// This assumes some cache-manifest trickiness.
//
// For Example:
//    FALLBACK:
//    /online.json /offline.json
(function () {
  "use strict";

  var request = require('ahr2')
    , EventEmitter = require('events.node').EventEmitter
    ;

  function create(options) {
    options = options || {};

    var period = options.period || 1000
      , resource = options.resource
      , emitter = new EventEmitter()
      , status;

    function testOnline() {
      var date = Date.now();

      request(resource + '?_nocache=' + date).when(function (err, xhr, data) {
        try {
          data = JSON.parse(data);
        } catch(e) {
          emitter.emit('offline');
          throw new Error("Cache-Manifest or resource incorrect: " + JSON.stringify(e));
        }

        if (status === data.status) {
          return;
        }

        // XXX remove this debug code
        console.log("status changed: " + status + " => " + data.status);
        status = data.status;
        emitter.emit(data.status);
      });

    }

    setInterval(testOnline, period);
    testOnline();

    return emitter;
  }

  module.exports = {
    create: create
  };
}());
